/* -*- mode:prolog; -*-
 ******************************************************************
 * $Id$
 * Copyright (C) 2008 by INRIA 
 * Author: Eric de la Clergerie <Eric.De_La_Clergerie@inria.fr>
 * ----------------------------------------------------------------
 *
 *  fsa.pl -- Implementation jouet des FSA
 *
 * ----------------------------------------------------------------
 * Description
 *
 *   Implementation jouet des automates  tats finis (FSA) en
 *   Prolog/DyALogImplementation jouet des automates  tats finis
 *   (FSA) en Prolog/DyALog
 *
 * ----------------------------------------------------------------
 */

%% Import de la bibliothque DyALog pour l'impression
:-require 'format.pl'.

%% Directive extensional pour dfinir des prdicats bases de donnes
%% Ici, les prdicats extensionels dfinissant tats et transitions
%% d'un FSA
:-extensional trans/4.
:-extensional init_state/2.
:-extensional final_state/2.

%% Coeur du moteur FSA
fsa(Name,L,R) :-
	init_state(Name,Init_State),
	fsa(Name,Init_State,L,R).

fsa(Name,S,L,L) :- final_state(Name,S).
fsa(Name,S,L,R) :-
	trans(Name,S,T,A),
	fsa_action(A,L,M),
	fsa(Name,T,M,R)
	.

%% Les action du FSA
fsa_action(c(X),L,R) :- 'C'(L,X,R).
fsa_action(true,L,L).
fsa_action(range(D),L,R) :- 'C'(L,X,R),domain(X,D).

%% Le lecteur sur liste (en complment du lecteur sur treillis de mots)
:-extensional 'C'/3.
'C'([C|R],C,R).

%% Une requte possible
%% Lecture sur une liste prolog de symboles
?-argv([Name|L]),fsa(Name,L,[]).


